#ifndef _SnSFsfunction
#define _SnSFsfunction

#include "SnSF.hpp"
#include "SnSFtransform.hpp"

using namespace std;



class SnSF::Sfunction{
public:

  Sfunction(const Sfunction& o);
  Sfunction(const Function& o);
  Sfunction(const Sfunction& o, const int offset, const int _size);

  Sfunction(const Transform& _transfm, const int _size=0);
  Sfunction(const FourierT& _T, const int _size=0);

  Sfunction(const Fourier& f);

  Sfunction(const Fourier& F, FIELD* _f);
  ~Sfunction();


  Fourier* fft();

  string str() const;

public:

  const FourierT& T;
  const bool protect;
  const int width;

  int size;
  int* index;
  FIELD* f;

};

#endif
