#include "SnSFtransformBank.hpp"

const Transform::Left& SnSF::TransformBank::Left::operator()(int n, int k1, int k2){
  if(k1==0) k1=1;
  if(k2==0) k2=1;
  for(int i=0; i<trf.size(); i++)
    if(tn[i]==n && tk1[i]==k1 && tk2[i]==k2) return *trf[i];
  if(k2==1) trf.push_back(new Transform::Left(n,k1));
  else{
    const Transform::Left& lT=(*this)(n,k2);
    const Transform::Left& rT=(*this)(n,k1);
    trf.push_back(new Transform::Left(InnerProduct<Transform>(lT,rT)));
  }
  tn.push_back(n);
  tk1.push_back(k1);
  tk2.push_back(k2);
  return *trf[trf.size()-1]; 
}

