#include "SnSFclasses.hpp"

#define _branchCounter
#define _ops

#ifdef _branchCounter
ScalarCounter branchCounter;
#endif

#ifdef _ops
ScalarCounter ops;
#endif

using namespace SnSF;

main(int argc, char** argv){

  const int n=4;
  
  Transform::Left T1(n,n-2);
  Function f1(T1);
  f1.randomize();
  Fourier F1(f1);
  cout<<F1.str()<<endl;

  Transform::Left T2(n,n-2);
  Function f2(T2);
  f2.randomize();
  Fourier F2(f2);
  cout<<F1.str()<<endl;

  Transform::Left T(OuterProduct<Transform>(T1,T2));
  //cout<<T.str()<<endl;

  //Fourier F(T.top(),OuterProduct<Fourier>(F1,F2));
  //cout<<endl<<F.str()<<endl;

  //Function f(F);
  //cout<<f.str()<<endl;

  //Fourier Fdash(f);
  //cout<<Fdash.str()<<endl;

  cout<<"Thresholding..."<<endl<<endl;
  /*
  Transform::Left Tthresh(n,1);
  Fourier* Fthresh=F.threshold(1.7,&Tthresh.top());
  if(Fthresh!=NULL){
    cout<<Fthresh->str()<<endl;
    Function fthresh(*Fthresh);
    cout<<fthresh.str()<<endl;
  }
  */

}
