#include "SnSFclasses.hpp"

//#include "Sn.hpp"
//#include "SnFunction.hpp"
//#include "SnFourierTransform.hpp"

#define _branchCounter
#define _ops

#ifdef _branchCounter
ScalarCounter branchCounter;
#endif

#ifdef _ops
ScalarCounter ops;
#endif

using namespace SnSF;

main(int argc, char** argv){

  const int n=6;

  //Partition limit(1,1,NULL);
  //Transform::Left T(n,n-2,&limit);
#if 0

  Transform::Left T(2,1);
  ifstream ifs("6.4.lim.1.1.trf",ios::binary);
  T.readfrom(ifs);
  ifs.close();

  cout<<T.str()<<endl;

  Function f(T);
  f.randomize();
  cout<<f.str()<<endl;

  Fourier F(f);
  cout<<F.str()<<endl;

  Function fdash(F);
  cout<<fdash.str()<<endl;

#endif

#if 0
  
  vector<int> best; 
  cout<<F.max(best,0)<<endl;
  for(int i=0; i<best.size(); i++) cout<<best[i]; cout<<endl;

  Fourier* Fthresh=F.threshold(0.5);
  Function fthresh(*Fthresh);
  cout<<fthresh.str()<<endl;

  Sn::Sn G(n);
  Sn::Function fb(G,f);
  Sn::FourierTransform Fb(fb);
  cout<<Fb.str()<<endl;
  
  ComponentT& C=*(T[0]->at(1));
  for(int tau=1; tau<n; tau++){
    cout<<"---------------------"<<endl<<"tau="<<tau<<endl;
    for(int i=0; i<C.rowlabels.size(); i++){
      int index=i*(n-1)+tau-1; 
      cout<<C.YORleftT[index]<<" "<<C.YORleft1[index]<<" "<<C.YORleft2[index]<<endl;
    }
  }
#endif 

}
