#include "SnSFclasses.hpp"
#include "Permutation.hpp"

#define _branchCounter
#ifdef _branchCounter
ScalarCounter branchCounter;
#endif

using namespace SnSF;

main(int argc, char** argv){

  int n=6; if(argc>=2) sscanf(argv[1],"%d",&n);
  int I[n]; for(int i=0; i<n; i++) I[i]=n-i;

  Transform::Left T(n);
  Fourier F(T.top(),n-1,I);

  Permutation::Random pi(n);
  vector<int> cclist(pi.cclist());
  for(int i=0; i<n; i++) F.rotateLeft(cclist[n-1-i],1,n-i);

  cout<<pi<<endl;
  cout<<F<<endl;
  
  Fourier Id(F.T,Product<Fourier,Transpose<Fourier> >(F,~F));
  cout<<Id<<endl;


}
