#ifndef _AssignmentMatrix
#define _AssignmentMatrix

#include "Fmatrix.hpp"
#include "Vector.hpp"

class AssignmentMatrix: public Fmatrix{
public:

  AssignmentMatrix(const int _Nrows, const int _Ncols);
  AssignmentMatrix(const Fmatrix &F);
  ~AssignmentMatrix();

  double KuhnMunkres();
  
  bool Augment();
  bool addx(const int x);

  int n;

  int Nassignments;
  Vector<FIELD> yx;
  Vector<FIELD> yy;
  Vector<int> assignedx; // who is x assigned to
  Vector<int> assignedy; // who is y assigned to 
  Vector<bool> foundx;
  Vector<bool> foundy;

};


#endif
