#ifndef __BLOCK_MATRIX_HPP__
#define __BLOCK_MATRIX_HPP__

#include <vector>

#include "Fmatrix.hpp"
#include "FGmatrix.hpp"
#include "InheritableVector.hpp"

Fmatrix blockMatrix(const std::vector<Fmatrix *> &blocks);
Fmatrix blockMatrix(const std::vector<const Fmatrix *> &blocks);

FGmatrix blockMatrix(const std::vector<FGmatrix *> &blocks);
FGmatrix blockMatrix(const std::vector<const FGmatrix *> &blocks);

#endif // #ifndef __BLOCK_MATRIX_HPP__
