#include "Format.hpp"

#include <cstdarg>
#include <cstdio>

std::string stringFormat(const char *format, ...)
{
  va_list ap;
  char dummy_buf[1];
  
  // Allocate
  va_start(ap, format);
  int n = vsnprintf(dummy_buf, 0, format, ap);
  va_end(ap);

  char *s = new char[n+2];

  // Format
  va_start(ap, format);
  vsnprintf(s, n+1, format, ap);
  va_end(ap);

  // Finish
  std::string ret(s);
  delete [] s;
  return ret;
}
