#ifndef __CLUSTER_LINALG_H__
#define __CLUSTER_LINALG_H__

#include <stdlib.h>

void linalg_print(size_t m, size_t n, const double *A);

void linalg_sqrt(size_t n, double *sqrt, const double *A);

void linalg_first_order(size_t m, size_t n, double alpha, const double *x, const double *y, double *A);

#endif // #ifndef __CLUSTER_LINALG_H__
