#ifndef __PROJECT_H__
#define __PROJECT_H__

/**
 * Project a vector x onto the nullspace of an $m \times n$ matrix $A$.
 *
 * @arg @c A The matrix such that $Ax = 0$ on output.  Given in row-major order.
 */
void project_nullspace(int m, int n, const double *A, double *x);

#endif // #ifndef __PROJECT_H__
