#ifndef __STOCHASTIC_GRADIENT_HPP__
#define __STOCHASTIC_GRADIENT_HPP__

#include "QAPbranch.hpp"

void stochasticGradient(
  const std::vector<QAPSum> &train, const std::vector<Permutation> &truth,
  QAPSum::Weights &w,
  int niters, double lambda);

#endif // #ifndef __STOCHASTIC_GRADIENT_HPP__
