%authors: vsingh
function retM = deeptiN1N2(M, N, bnd)

    % M = F3
    % N = F

    n = size(M,1);
   
    %cvx code start
    cvx_begin;

        variable A21(n,n)
        variable M1(n,n);
        variable M2(n,n);
        variable Z1(2*n,2*n) symmetric;

        minimize norm(A21 - M,'fro')
        subject to

            [M1 (A21*N); (A21*N)' M2] == Z1;
            Z1 == semidefinite(2*n);
            A21(n-5:n,n-5:n) == M(n-5:n,n-5:n);
            (0.5*trace(M1) + 0.5*trace(M2)) <= bnd;

    cvx_end;

    retM = A21;
end