n = 10;  
A11 = rand(n,n);
e = ones(n);

thisnucnorm = norm_nuc(A11)

cvx_begin
variable A21(n,n)
variable M1(n,n);
variable M2(n,n);
variable Z1(2*n,2*n) symmetric;

minimize norm((ones(n)-A21),2)
subject to

A21 >= 0;
[M1 A11.*A21; A11'.*A21' M2] == Z1;
Z1 == semidefinite(2*n);
Z1 >= 0;
(0.5*trace(M1) + 0.5*trace(M2)) <= thisnucnorm-0.05;
cvx_end

norm_nuc(A11)
norm_nuc(A11')
0.5*(trace(M1) + trace(M2))

norm_nuc(A11.*full(A21))
norm_nuc(A11'.*full(A21'))