%authors: vsingh
function [retM1 retM2 retM3] = vikasN1N2_new(M, N, wold, bnd)

    % M = F3
    % N = F
    
    retM1 = 0;
    retM2 = 0;
    retM3 = 0;
    
    runcvx = 1;
    runyalmip = 0;
    
    n = size(M,1);
    
    if (nargin < 3)
        bnd = norm_nuc(M*N) - 1e-3;
    end


    bnd
    
    %cvx code start
    if (runcvx)
    tic
    cvx_begin;

        variable A21(n,n)
        variable M1(n,n);
        variable M2(n,n);
        variable Z1(2*n,2*n) symmetric;

        minimize norm(A21 - M,2)
        subject to

            [M1 ((A21.*M)*N); ((A21.*M)*N)' M2] == Z1;
            Z1 == semidefinite(2*n);
            (0.5*trace(M1) + 0.5*trace(M2)) <= bnd;
            A21 >= 0;
            sum(sum(A21)) == n*n;

    cvx_end;
    retM1 = A21;
    toc
    input('')
    end
    


  
    
        
    yA21 = sdpvar(n,n,'full');
    yM1  = sdpvar(n,n,'symmetric');
    yM2  = sdpvar(n,n,'symmetric');
    yZ1  = sdpvar(n,n,'full');
    bigmat  = sdpvar(2*n,2*n,'full');
    traceym1 = sdpvar(1,1);
    traceym2 = sdpvar(1,1);
    
    diff = yA21(:)-M(:);
    

%    F = [ [yM1 (yA21*N); (yA21*N)' yM2] >= 0];
F = [bigmat == [yM1 ((yA21.*M)*N); ((yA21.*M)*N)' yM2]];
F = F + [bigmat >= 0];
    %F = F + [(0.5*trace(yM1) + 0.5*trace(yM2)) <= bnd];
F = F + [trace(bigmat) <= 2*bnd];
F = F + [yA21(:) >= 0];
F = F + [ sum(yA21(:)) == n*n ];

 if (runyalmip)
     tic
    solvesdp(F,norm(diff,'fro'));
    retM2 = double(yA21);
    input('')
    toc
 end

    tic
    %solvesdp(F,norm(yA21 - M, 2),sdpsettings('solver','sdpnal','debug',1));
    solvesdp(F,norm(wold - yA21, 2),sdpsettings('solver','sdpnal','debug',1));

    retM3 = double(yA21);
    toc
    input('')
    
    
end

