#include "SnSFclasses.hpp"

#include "SnSFsfunction.hpp"

#define _branchCounter
#define _ops

#ifdef _branchCounter
ScalarCounter branchCounter;
#endif

#ifdef _ops
ScalarCounter ops;
#endif

using namespace SnSF;

main(int argc, char** argv){

  Transform::Left T(4);

  SnSF::Function f(T);
  //f.randomize();
  for(int i=0; i<T.top().order; i++)
    if (((double) rand())/((double)RAND_MAX+1)>0.8) f.f[i]=((double) rand())/((double)RAND_MAX+1); 
  cout<<f.str()<<endl;

  SnSF::Sfunction sf(f);
  cout<<sf.str()<<endl;

  SnSF::Function fdash(sf);
  cout<<fdash.str()<<endl;

  SnSF::Fourier F(f);
  cout<<F.str()<<endl;

  SnSF::Fourier SF(sf);
  cout<<SF.str()<<endl;

}
