#ifndef _PartitionB
#define _PartitionB

#include <vector>
#include <string>
#include "InheritableVector.hpp"

//class PartitionB;

//#include "SnElement.hpp"

using namespace std;


class PartitionB : public InheritableVector<int>{
public:

  PartitionB(){};
  PartitionB(const PartitionB& o);
  PartitionB( int a, ...); 
  // PartitionB(const Sn::Element& sigma); 

  int readfrom(ifstream& ifs);
  int writeto(ofstream& ofs) const;

  bool operator==(const PartitionB& o) const;
  bool limitedby(const PartitionB& o) const;

  int n() const {int result=0; for(int i=0; i<size(); i++) result+=at(i); return result;};

  vector<PartitionB> restrictions() const;
  vector<PartitionB> extensions() const;

  string str() const; 

};

#endif
