#ifndef _Tableau
#define _Tableau

//#include "LatticeClasses.hpp"
#include "PartitionB.hpp"

using namespace std;

class Tableau
{
public:

  Tableau(int n=1);
  Tableau(const PartitionB& _shape);

  int readfrom(ifstream& ifs);
  int writeto(ofstream& ofs) const;

  bool operator==(const Tableau& o) const {return row==o.row;}

  Tableau& growTo(const PartitionB& p);
  string str() const;

  PartitionB shape;
  vector<int> row;
  vector<int> col;
};


#endif
