#include "Thread.hpp"

extern "C" {
  static void *start_routine(void *arg)
  {
    Thread *t = reinterpret_cast<Thread *>(arg);
    t->run();
    return NULL;
  }
}

void Thread::start()
{
  pthread_create(&thread, NULL, start_routine, this);
}

void Thread::join()
{
  pthread_join(thread, NULL);
}
