#include "AssignmentMatrix.hpp"
#include "Permutation.hpp"

#include <cstdlib>

//#include "Sn.hpp"
//#include "SnElement.hpp"

main(){

  const int n=5;
  
  AssignmentMatrix C(n,n);
  for(int i=0; i<n; i++)
    for(int j=0; j<n; j++)
      C(i,j)=((double) rand())/((double)RAND_MAX+1);

  cout<<C.str()<<endl;

#if 0
  Sn::Sn G(n);
  for(int i=0; i<G.order; i++){
    Sn::Element* pi=G[i];
    double cost=0;
    for(int i=0; i<n; i++)
      cost+=C(i,pi->action(i+1)-1);
    cout<<pi->str()<<" "<<cost<<endl;
  }
#endif

  cout<<C.KuhnMunkres()<<endl;

  for(int i=1; i<=120; i++){
    Permutation p(pair<int,int>(5,i));
    double t=0;
    //cout<<p<<endl;
    for(int j=0; j<5; j++) t+=C(j,p[j]-1);
    cout<<p<<" "<<t<<endl;
  }
  

}
