#include "Matlab.hpp"

#include <cstdlib>
#include <ctime>

#include <iostream>
using std::cout; using std::endl;

int main(int argc, char **argv)
{
  srand(time(NULL));

  const size_t n = 4;
  FGmatrix::Random A(false, n, n), B(false, n, n);
  cout<<"A = "<<endl<<A<<endl;
  cout<<"B = "<<endl<<B<<endl;

  matlab::Engine mat;

  mat.setVariable("A", A);
  mat.setVariable("B", B);

  mat.execute("C = A + B;");

  cout<<"A + B = "<<endl;
  cout<<mat.getVariable("C")<<endl;

  return 0;
}
